Get Bing ‘Search Volume History’ Results by id

‌This endpoint will provide you with historical search volume data for up to 1000 keywords in one request. You can get search volume for keywords in monthly, weekly, or daily format and specify the device type.

checked GET
Pricing

Your account will be charged only for posting a task. You can get the results of the task within the next 30 days for free.
The cost can be calculated on the Pricing page.

Description of the fields for sending a request:

Field nameTypeDescription
idstring

task identifier
unique task identifier in our system in the UUID format
you will be able to use it within 30 days to request the results of the task at any time



As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        devicestring

device type in a POST array
if there is no data, then the value is_nulln

        periodstring
        searchesobject
            desktopobject

device type = desktop
contains historical search volume data for searches made from desktop devices

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            non_smartphonesobject

device type = non-smartphones
contains historical search volume data for searches made from feature phones (non-smartphone mobile devices)

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            mobileobject

device type = mobile
contains historical search volume data for searches made from mobile devices

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            tabletobject

device type = tablet
contains historical search volume data for searches made from tablets

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
id="10081455-0001-0110-0000-c75b21dcca1c" 
curl --location --request GET "https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/task_get/${id}" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw ""
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
try {
	$result = array();
	// #1 - using this method you can get a list of completed tasks
	// in addition to 'search_volume_history' you can also set other parameters
	// the full list of possible parameters is available in documentation
	// GET /v3/keywords_data/bing/search_volume_history/tasks_ready
	$tasks_ready = $client->get('/v3/keywords_data/bing/search_volume_history/tasks_ready');
	// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
	if (isset($tasks_ready['status_code']) AND $tasks_ready['status_code'] === 20000) {
		foreach ($tasks_ready['tasks'] as $task) {
			if (isset($task['result'])) {
				foreach ($task['result'] as $task_ready) {
					// #2 - using this method you can get results of each completed task
					// GET https:/v3/keywords_data/bing/search_volume_history/task_get/$id
					if (isset($task_ready['endpoint'])) {
						$result[] = $client->get($task_ready['endpoint']);
					}
					// #3 - another way to get the task results by id
					// GET /v3/keywords_data/bing/search_volume_history/task_get/$id
					/*
					if (isset($task_ready['id'])) {
						$result[] = $client->get('/v3/keywords_data/bing/search_volume_history/task_get/' . $task_ready['id']);
					}
					*/
				}
			}
		}
	}
	print_r($result);
	// do something with result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const task_id = '02231934-2604-0066-2000-570459f04879';

const axios = require('axios');

axios({
    method: 'get',
    url: 'https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/task_get/' + task_id,
    auth: {
        username: 'login',
        password: 'password'
    },
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
# 1 - using this method you can get a list of completed tasks
# in addition to 'search_volume_history' you can also set other parameters
# the full list of possible parameters is available in documentation
# GET /v3/keywords_data/bing/search_volume_history/tasks_ready
response = client.get("/v3/keywords_data/bing/search_volume_history/tasks_ready")
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response['status_code'] == 20000:
    results = []
    for task in response['tasks']:
        if (task['result'] and (len(task['result']) > 0)):
            for resultTaskInfo in task['result']:
                # 2 - using this method you can get results of each completed task
				# GET /v3/keywords_data/bing/search_volume_history/task_get/$id
                if(resultTaskInfo['endpoint']):
                    results.append(client.get(resultTaskInfo['endpoint']))
                '''
                # 3 - another way to get the task results by id
                # GET /v3/keywords_data/bing/search_volume_history/task_get/$id             
                if(resultTaskInfo['id']):
                    results.append(client.get("/v3/keywords_data/bing/search_volume_history/task_get/" + resultTaskInfo['id']))
                '''
    print(results)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_task_get()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            // #1 - using this method you can get a list of completed tasks
            // in addition to 'search_volume_history' you can also set other parameters
            // the full list of possible parameters is available in documentation
            // GET /v3/keywords_data/bing/search_volume_history/tasks_ready
            var response = await httpClient.GetAsync("/v3/keywords_data/bing/search_volume_history/tasks_ready");
            var tasksInfo = JsonConvert.DeserializeObject<dynamic>(await response.Content.ReadAsStringAsync());
            var tasksResponses = new List<object>();
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (tasksInfo.status_code == 20000)
            {
                if (tasksInfo.tasks != null)
                {
                    foreach (var tasks in tasksInfo.tasks)
                    {
                        if (tasks.result != null)
                        {
                            foreach (var task in tasks.result)
                            {
                                if (task.endpoint != null)
                                {
                                    // #2 - using this method you can get results of each completed task
                                    // GET /v3/keywords_data/bing/search_volume_history/task_get/$id
                                    var taskGetResponse = await httpClient.GetAsync((string)task.endpoint);
                                    var taskResultObj = JsonConvert.DeserializeObject<dynamic>(await taskGetResponse.Content.ReadAsStringAsync());
                                    if (taskResultObj.tasks != null)
                                    {
                                        var fst = taskResultObj.tasks.First;
                                        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
                                        if (fst.status_code >= 40000 || fst.result == null)
                                            Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
                                        else
                                            tasksResponses.Add(fst.result);
                                    }
                                    // #3 - another way to get the task results by id
                                    // GET /v3/keywords_data/bing/search_volume_history/task_get/$id
                                    /*
                                    var tasksGetResponse = await httpClient.GetAsync("/v3/keywords_data/bing/search_volume_history/task_get/$id" + (string)task.id);
                                    var taskResultObj = JsonConvert.DeserializeObject<dynamic>(await tasksGetResponse.Content.ReadAsStringAsync());
                                    if (taskResultObj.tasks != null)
                                    {
                                        var fst = taskResultObj.tasks.First;
                                        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
                                        if (fst.status_code >= 40000 || fst.result == null)
                                            Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
                                        else
                                            tasksResponses.Add(fst.result);
                                    }
                                    */
                                }
                            }
                        }
                    }
                }
                if (tasksResponses.Count > 0)
                    // do something with result
                    Console.WriteLine(String.Join(Environment.NewLine, tasksResponses));
                else
                    Console.WriteLine("No completed tasks");
            }
            else
                Console.WriteLine($"error. Code: {tasksInfo.status_code} Message: {tasksInfo.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20240626",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07101317-1535-0260-0000-5f5e20c3d82e",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "keywords_data",
        "bing",
        "search_volume_history",
        "task_get",
        "07101317-1535-0260-0000-5f5e20c3d82e"
      ],
      "data": {
        "api": "keywords_data",
        "function": "search_volume_history",
        "se": "bing",
        "id": "07101317-1535-0260-0000-5f5e20c3d82e",
        "location_code": 2840,
        "language_code": "en",
        "keywords": [
          "10 minute timer"
        ]
      },
      "result": [
        {
          "keyword": "10 minute timer",
          "location_code": 2840,
          "language_code": "en",
          "device": [
            "desktop",
            "non_smartphones",
            "mobile",
            "tablet"
          ],
          "period": "monthly",
          "searches": {
            "desktop": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 19137
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 30887
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 36423
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 51340
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 66649
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 74974
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 66793
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 75869
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 76204
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 58507
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 38496
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 29263
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 32979
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 36368
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 37556
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 43481
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 39389
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 42348
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 39122
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 40490
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 38987
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 38622
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 30143
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 23803
              }
            ],
            "non_smartphones": [
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 3
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 3
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 1
              }
            ],
            "mobile": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 1046
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 1090
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 970
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 1554
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 1300
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 1657
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 1787
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 1680
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 1935
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 1880
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 1813
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 1192
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 1555
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 1331
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 1184
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 1186
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 852
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 1153
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 1641
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 1781
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 2883
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 2408
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 1658
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 1332
              }
            ],
            "tablet": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 750
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 616
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 627
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 814
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 731
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 804
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 769
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 670
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 712
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 602
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 609
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 695
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 815
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 730
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 709
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 747
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 647
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 779
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 697
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 722
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 719
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 660
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 589
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 684
              }
            ]
          }
        }
      ]
    }
  ]
}